extends Reference
# This file is an optional base class to inherit, to help centralize some boilerplate code.
#
# You can choose not to inherit it but then you'll have to include the boilerplate directly in your script.
# note that this script is not directly loaded by the game, since its file name begins with a "."


# api_version
#
# update this to match the game's api_version number, otherwise there will be warnings that your scripts are out-of-date 

const api_version = 200414

# on_program_load
#
# OVERRIDE THIS in each script. this is where you connect your callback funcs to the api's signals
# (the game calls this func on all mods that provide it, after all mods are loaded)

func on_program_load():
	pass


# get_mod_version(), if provided, is called by the game when listing loaded scripts. Update it here or override it. 

func get_mod_version():
	return "0.0.1"
	

# Everything below this point is boilerplate

const API = preload("res://.API.gd")
var api: API

func _set_api(game_api: API) -> void:
	api = game_api

