extends ".base.gd"

# private 
var lib


#
# The members and functions below are predefined functions that the game will call
#

const signature = 'AGM-ICONS'  # any string you want, but it should be readable and unique

# for a normal game, this example mod should not be loaded. 
# return false or delete the function entirely to experiment with this script.
func do_not_load():
	return false


func on_program_load():
	# get an instance of the mods/default/library.gd object
	api.print_node_paths("/root/Main/Game/SystemMap")
	lib = api.get_instance_by_signature('DefaultLibrary-J8PM1')
	
	# register a testing callback for demo purposes
	api.connect_callback_test(self)
	
	var test_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Commanders")
	
	var test_button_size = test_button.get_custom_minimum_size();
		
	# note: the game can only load PNG and JPG textures.
	# passing 'self' is necessary so the api knows to whom the path is relative

		
	var commander_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Commanders")
	var colony_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ColonySummary")
	var industry_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/IndustrialProduction")
	var research_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Research")
	var wealth_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Wealth")
	var ground_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/GroundForces")
	var design_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ClassDesign")
	var ships_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Ships")
	var fleetoders_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/FleetOrders")
	var taskforces_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/TaskForces")
	var fighters_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Fighters")
	var combat_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/CombatOverview")
	var system_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/SystemView")
	var galaxy_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/GalacticMap")
	var race_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/RaceDetails")
	var part_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/CreateResearchProject")
	var potcolony_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/PotentialColonies")
	var fuel_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/FuelSituation")
	var repair_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ShipsRequiringRepair")
	var prodoverview_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ProductionOverview")
	var tech_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ViewTechnology")
	var geo_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/GeologicalSurveyReport")
	var civ_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/ShippingLineInformation")
	var sector_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Sectors")
	var refresh_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Refresh")
	var events_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/Events")
	var spy_button = api.get_node("/root/Main/Game/SystemMap/SystemMapButtons/IntelligenceWindow")
	
	var commanderstex = api.load_texture("icons/Commanders.png", self)
	var tex = api.load_texture("icons/derp.png", self)
	var classdesigntex = api.load_texture("icons/Class Design.png", self)
	var colonysummarytex = api.load_texture("icons/Colony Summary.png", self)
	var combatoverviewtex = api.load_texture("icons/Combat Overview.png", self)
	var researchprojecttex = api.load_texture("icons/Create Research Project.png", self)
	var eventstex = api.load_texture("icons/Events.png", self)
	var fighterstex = api.load_texture("icons/Fighters.png", self)
	var fleetorderstex = api.load_texture("icons/Fleet Orders.png", self)
	var fuealsitex = api.load_texture("icons/Fuel Situation.png", self)
	var galaxymaptex = api.load_texture("icons/Galatic Map.png", self)
	var geosurveytex = api.load_texture("icons/Geological Survey Report.png", self)
	var groundforcestex = api.load_texture("icons/Ground Forces.png", self)
	var industrialprodtex = api.load_texture("icons/Industrial Production.png", self)
	var intelligencetex = api.load_texture("icons/Intelligence.png", self)
	var potcoloniestex = api.load_texture("icons/Potential Colonies.png", self)
	var prodoverviewtex = api.load_texture("icons/Production Overview.png", self)
	var racetex = api.load_texture("icons/Race Details.png", self)
	var refreshtex = api.load_texture("icons/Refresh.png", self)
	var researchtex = api.load_texture("icons/Research.png", self)
	var sectortex = api.load_texture("icons/Sectors.png", self)
	var shippinglinetex = api.load_texture("icons/Shipping Line Information.png", self)
	var repairtex = api.load_texture("icons/Ships Requiring Repair.png", self)
	var shipstex = api.load_texture("icons/Ships.png", self)
	var systemtex = api.load_texture("icons/System View.png", self)
	var taskforcetex = api.load_texture("icons/Task Forces.png", self)
	var techstex = api.load_texture("icons/View Technology.png", self)
	var wealthtex = api.load_texture("icons/Wealth.png", self)
	
	commander_button.set_button_icon(commanderstex)  
	colony_button.set_button_icon(colonysummarytex)  
	industry_button.set_button_icon(industrialprodtex)  
	research_button.set_button_icon(researchtex)  
	wealth_button.set_button_icon(wealthtex)  
	ground_button.set_button_icon(groundforcestex)  
	design_button.set_button_icon(classdesigntex)  
	ships_button.set_button_icon(shipstex)  
	fleetoders_button.set_button_icon(fleetorderstex)  
	taskforces_button.set_button_icon(taskforcetex)  
	fighters_button.set_button_icon(fighterstex)  
	combat_button.set_button_icon(combatoverviewtex)  
	system_button.set_button_icon(systemtex)  
	galaxy_button.set_button_icon(galaxymaptex)  
	race_button.set_button_icon(racetex)  
	part_button.set_button_icon(researchprojecttex)  
	potcolony_button.set_button_icon(potcoloniestex)  
	fuel_button.set_button_icon(fuealsitex)  
	repair_button.set_button_icon(repairtex)  
	prodoverview_button.set_button_icon(industrialprodtex)  
	tech_button.set_button_icon(techstex)  
	geo_button.set_button_icon(geosurveytex)  
	civ_button.set_button_icon(shippinglinetex)  
	sector_button.set_button_icon(sectortex)  
	refresh_button.set_button_icon(refreshtex)  
	events_button.set_button_icon(eventstex)  
	spy_button.set_button_icon(intelligencetex)  
	
	commander_button.set_button_icon(commanderstex)  
	
	# every button has 5 states. the disabled state is not shown here. These are documented at
	# http://docs.godotengine.org/en/3.2/classes/class_button.html   (search for StyleBox).
	# if you click StyleBox in the doc, you'll find the stylebox is a resource.
	# most resources are shared, so to be safe duplicate them first (but you can reuse your copy)
	# there are 4 types of styleboxes.  you could test with the code:  'if stylebox is StyleBoxFlat'
	# set_bg_color is documented here http://docs.godotengine.org/en/3.2/classes/class_styleboxflat.html#class-styleboxflat
	# writing the stylebox back to the button isn't documented very well. you have to use set(). 
	# how do you know the exact string to used needs to be "custom_style/pressed" ? in a dummy godot project,
	# you would have to create an example button, expand the Custom Styles section in the Inspector, and mouse over
	# each row to see the property name.  
	#var stylebox = commander_button.get_stylebox("pressed").duplicate() 
	#stylebox.set_bg_color(Color("#000000"))
	#commander_button.set("custom_styles/pressed", stylebox)
	
	#stylebox = commander_button.get_stylebox("focus").duplicate() 
	#stylebox.set_bg_color(Color("#330022"))  # note the blue border around the focused button is preserved since we're tweaking an existing style
	#commander_button.set("custom_styles/focus", stylebox)
	
	#stylebox = commander_button.get_stylebox("normal").duplicate() 
	#stylebox.set_bg_color(Color("#330022"))
	#commander_button.set("custom_styles/normal", stylebox)
	
	#stylebox = commander_button.get_stylebox("hover").duplicate() 
	#stylebox.set_bg_color(Color("#880066")) 
	#commander_button.set("custom_styles/hover", stylebox)
	
	# example of changing a control's size.  see http://docs.godotengine.org/en/3.2/classes/class_control.html#class-control-property-rect-min-size
	#var min_size = commander_button.get_custom_minimum_size()
	#min_size.x += 20
	#commander_button.set_custom_minimum_size(min_size)
	
	
	

func get_mod_name():
	return "AGM's Custom icons"

# note: if you compare the functions in this section with the functions in default/precursors.gd,
# you'll see that we're intentionally excluding a bunch of functions that are optional.

#
# Below are the callbacks we set up in on_program_load()
#

# on_callback_test is called when the Test button is pressed on the mod list in game
func on_callback_test(chalkboard, _context):
	if lib == null:
		return
		
	# here is an example showing how to ensure that this callback should be called ONLY AFTER
	# a foreign mod (in this case, default/library.gd) has already run it's copy of 'on_callback_test'
	# the reason this works is default/library.gd has the following in its on_callback_test function:
	#   chalkboard[signature] = 1
	#
	if !chalkboard.has(lib.signature):
		return api.Request.MoveMeToEnd
	
	# this prints to the mod loader window's text console
	api.println("example.gd: callback test")
	
	# this shows how to get a dump of all nodes in the game, so you can find the path you want and pass it to api.get_node
	lib.print_node_paths("/root/Main/Game/")
	
